#include "linked_list.h"

list_node_t *
llist_node(void *data)
{
    list_node_t *node = malloc(sizeof(list_node_t));
    if(node == NULL) return node;

    node->data = data;
    node->next = NULL;

    return node;
}

list_node_t *
llist_append(list_node_t *list, void *data)
{
    for(; list->next != NULL; list = list->next);
    list_node_t* new = llist_node(data);
    list->next = new;
    return new;
}

list_node_t *
llist_prepend(list_node_t **list, void *data)
{
    list_node_t* new = llist_node(data);
    if(new != NULL) {
	new->next = *list;
	*list = new;
    }

    return new;
}

void *
llist_at(list_node_t *list, size_t n)
{
    for(int i = 0; i < n && list != NULL; list = list->next, i++);
    return list;
}


size_t
llist_length(const list_node_t *list)
{
    int i = 0;
    for(; list != NULL; list = list->next, ++i);
    return i;
}
