#ifndef RPC_LINKED_LIST_H
#define RPC_LINKED_LIST_H

#include <stdlib.h>

typedef struct list_node_s {
    struct list_node_s *next;
    void *data;
} list_node_t;

list_node_t *
llist_node(void *data);

list_node_t *
llist_append(list_node_t *list, void *data);

list_node_t *
llist_prepend(list_node_t **list, void *data);

/**
 * Inserts at #n, or appends if shorter than #n.
 */
list_node_t *
llist_insert(list_node_t **list, size_t n, void *data);

void *
llist_at(list_node_t *list, size_t n);

size_t
llist_length(const list_node_t *list);

#endif // RPC_LINKED_LIST_H
